#include <GMLuaModule.h>

#include <eiface.h>

GMOD_MODULE(Open, Close);

ILuaInterface *gLua = NULL;
IVEngineServer *engine = NULL;

int GetPlayerEIndex(ILuaObject *playerEntity)
{
	ILuaObject *entityMT = gLua->GetMetaTable("Entity", GLua::TYPE_ENTITY);
		entityMT->GetMember("EntIndex")->Push();
		
		playerEntity->Push();

		gLua->Call(1, 1);
	entityMT->UnReference();

	return (gLua->GetReturn(0)->GetInt());
}

LUA_FUNCTION(QueryConVarValue)
{
	gLua->CheckType(1, GLua::TYPE_ENTITY);
	gLua->CheckType(2, GLua::TYPE_STRING);
	
	gLua->PushDouble(engine->StartQueryCvarValue(engine->PEntityOfEntIndex(GetPlayerEIndex(gLua->GetObject(1))), gLua->GetString(2)));
	
	return 1;
}

int Open(lua_State *L)
{
	gLua = Lua();

	CreateInterfaceFn engineFactory = Sys_GetFactory("engine.dll");

	engine = (IVEngineServer *)engineFactory(INTERFACEVERSION_VENGINESERVER, NULL);

	ILuaObject *playerMT = gLua->GetMetaTable("Player", GLua::TYPE_ENTITY);
		playerMT->SetMember("QueryConVarValue", QueryConVarValue);
	playerMT->UnReference();

	return 0;
}

int Close(lua_State *L)
{
	return 0;
}